# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with mead
%bcond_without repolib

%define reltag _patch01

%define repodir %{_javadir}/repository.jboss.com/apache-xmlsec/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free

Name:           xml-security
Version:        1.5.6
Release:        3%{?dist}
Epoch:          0
Summary:        Apache-XML-Security-J
License:        ASL 2.0
Group:          Development/Libraries
URL:            http://santuario.apache.org/javaindex.html
# svn export http://svn.apache.org/repos/asf/santuario/xml-security-java/tags/1.5.6 xml-security-1.5.6
# Exported revision 1553784.
# tar cjf xml-security-1.5.6.tar.bz2 xml-security-1.5.6
Source0:        xml-security-%{version}.tar.bz2
Source1:        xml-security-component-info.xml
Source2:        xml-security-jpp-depmap.xml
Patch0:         %{name}-pom.patch
#Patch1:         JBPAPP-10855.patch

Obsoletes:      apache-xmlsec <= 0:1.4.5-1.1_redhat_1%{?dist}
Provides:       apache-xmlsec = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       slf4j
Requires:       xalan-j2
Requires:       xerces-j2

BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  slf4j
BuildRequires:  jboss-parent
BuildRequires:  jpackage-utils
BuildRequires:  junit
BuildRequires:  xalan-j2
BuildRequires:  xml-commons-jaxp-1.3-apis
BuildRequires:  xerces-j2

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The Apache XML Security for Java library supports XML-Signature Syntax and Processing,
W3C Recommendation 12 February 2002 and XML Encryption Syntax and Processing, W3C Recommendation 10 December 2002.

%package javadoc
Summary:        API Documentation for xmlsec
Group:          Development/Tools
Requires:       jpackage-utils

%description javadoc
JavaDoc documentation for xmlsec.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%patch0 -p1

%build
export LC_ALL=en_US.UTF8
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g -XX:MaxPermSize=512M -Dproject.build.sourceEncoding=UTF8"
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -Dmaven2.jpp.depmap.file=%{SOURCE2} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -Dmaven.test.failure.ignore=true javadoc:aggregate javadoc:aggregate-jar deploy

%install
%{__rm} -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}
%if %with mead
%{__cp} -p %{_sourcedir}/xmlsec-%{version}.jar %{buildroot}%{_javadir}/xmlsec-%{version}.jar
%{__cp} -p %{_sourcedir}/xmlsec-%{version}-sources.jar %{buildroot}%{_javadir}/xmlsec-%{version}-sources.jar
%else
%{__cp} -p target/xmlsec-%{version}.jar %{buildroot}%{_javadir}/xmlsec-%{version}.jar
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{version}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%if %with mead
%{__cp} -p %{_sourcedir}/xmlsec-%{version}.pom %{buildroot}/%{_mavenpomdir}/JPP-xmlsec.pom
%else
cp -p pom.xml %{buildroot}%{_mavenpomdir}/JPP-xmlsec.pom
%endif
%add_to_maven_depmap org.apache.santuario xmlsec %{version} JPP xmlsec
[ -f %{buildroot}%{_mavendepmapfragdir}/xmlsec ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/xmlsec

# javadocs
%{__mkdir_p} %{buildroot}%{_javadocdir}/xmlsec-%{version}
%if %without mead
%{__unzip} -qq target/xmlsec-%{version}-javadoc.jar -d %{buildroot}%{_javadocdir}/xmlsec-%{version}
%{__rm} -r %{buildroot}%{_javadocdir}/xmlsec-%{version}/META-INF
%else
%{__unzip} -qq %{_sourcedir}/xmlsec-%{version}-javadoc.jar -d %{buildroot}%{_javadocdir}/xmlsec-%{version}
%{__rm} -r %{buildroot}%{_javadocdir}/xmlsec-%{version}/META-INF
%endif
%{__ln_s} xmlsec-%{version} %{buildroot}%{_javadocdir}/xmlsec

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

install -d -m 755 %{buildroot}%{repodir}
install -d -m 755 %{buildroot}%{repodirlib}
install -p -m 644 %{SOURCE1} %{buildroot}%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{version}-brew/g' %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
install -d -m 755 %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE2} %{buildroot}%{repodirsrc}
install -p -m 644 %{PATCH0} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_javadir}/xmlsec-%{version}.jar %{buildroot}%{repodirlib}/xmlsec.jar
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-xmlsec.pom %{buildroot}%{repodirlib}/xmlsec.pom
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap
                                                                                                     
%files
%defattr(0644,root,root,0755)
%doc NOTICE CHANGELOG.txt LICENSE
%{_javadir}*/xmlsec-%{version}.jar
%{_javadir}*/xmlsec.jar
%if %with mead
%{_javadir}*/xmlsec-%{version}-sources.jar
%{_javadir}*/xmlsec-sources.jar
%endif
%{_mavenpomdir}/JPP-xmlsec.pom
%{_mavendepmapfragdir}/xmlsec

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/xmlsec-%{version}
%{_javadocdir}/xmlsec

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Oct 02 2014 Hui Wang <huwang@redhat.com> 0:1.5.6-3
- Rebuid for CVE-2013-4517 for EAP 5.2.0

* Tue Feb 18 2014 Hui Wang <huwang@redhat.com> 0:1.5.6-2
- Update xml-security-pom.patch to remove apache-parent

* Sat Dec 28 2013 Hui Wang <huwang@redhat.com> 0:1.5.6-1.1
- Fix repolib

* Sat Dec 28 2013 Hui Wang <huwang@redhat.com> 0:1.5.6-1
- Upgrade to 1.5.6 (JBPAPP-10943)

* Mon Aug 26 2013 Hui Wang <huwang@redhat.com> 0:1.5.1-2_patch01
- Add a patch to fix JBPAPP-10855

* Mon Jul 09 2012 Martha Benitez <mbenitez@redhat> 0:1.5.1-1
- Upgrade to 1.5.1

* Fri Jan 14 2011 Hui Wang <huwang@redhat.com> - 0:1.4.3-6
- Rebuild
- Use deploy command instead of upload.sh

* Tue Nov 23 2010 Hui Wang <huwang@redhat.com> - 0:1.4.3-5
- Add upload.sh and content of maven2-brew to repolib
- Fix %%files for signed jars

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.4.3-4.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.4.3-4
- Rebuild

* Wed Nov 18 2009 Permaine Cheung <pcheung@redhat.com> 0:1.4.3-3
- Add pom and maven fragments

* Fri Aug 14 2009 Permaine Cheung <pcheung@redhat.com> 0:1.4.3-2
- Fix repodir

* Fri Aug 14 2009 Permaine Cheung <pcheung@redhat.com> 0:1.4.3-1
- Upgrade to 1.4.3

* Tue May 26 2009 David Walluck <dwalluck@redhat.com> 0:1.4.2-2
- fix log4j location in patch

* Tue May 26 2009 David Walluck <dwalluck@redhat.com> 0:1.4.2-1
- 1.4.2

* Mon Jan 12 2009 David Walluck <dwalluck@redhat.com> 0:1.3.0-3
- add compiled samples jar to demo subpackage
- specify xml-commons-jaxp-1.3-apis explicitly
- rename repolib directory for AS5
- fix repolib permissions
- fix repolib file ownership

* Wed May 28 2008 David Walluck <dwalluck@redhat.com> 0:1.3.0-2.jpp5
- don't remove buildroot in %%prep
- don't use absolute path for %%doc
- fix License

* Mon Apr 21 2008 David Walluck <dwalluck@redhat.com> 0:1.3.0-1jpp.ep1.3
- unpatched version requires ant-nodeps
- fix tests
- remove javadoc scriptlets
- remove %%{buildroot} in %%install
- rename BuildRoot

* Tue Mar 13 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:1.3.0-1jpp.ep1.2
- Fix repolib location

* Tue Mar 13 2007 Fernando nasser <fnasser@redhat.com> 0:1.3.0-1jpp.ep1.1
- Remove duplicate macros

* Tue Feb 20 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:1.3.0-1jpp.el4ep1.2
- Install jar with name as used upstream
- Add -brew suffix

* Sun Feb 18 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:1.3.0-1jpp.el4ep1.1
- Add repolib support
- Add missing BR on ant-junit

* Tue Aug 01 2006 Fernando nasser <fnasser@redhat.com> 0:1.3.0-1jpp_1rh
- Merge with upstream

* Tue Jan 17 2006 Deepak Bhole <dbhole@redhat.com> 0:1.3.0-1jpp
- Upgrade to version 1.3.0.
- Removed com.sun dependencies.
- Removed bouncycastle dependency.

* Thu Oct 20 2005 Fernando nasser <fnasser@redhat.com> 0:1.2.1-1jpp_1rh
- First Red Hat build
- Remove bouncycastle
- Lower Xalan-j2 requires to 2.6.0

* Mon Oct 10 2005 Ralph Apel <r.apel at r-apel.de> 0:1.2.97-1jpp
- Upgrade to build/run with JAXP-1.3

* Mon Apr 04 2005 Ralph Apel <r.apel at r-apel.de> 0:1.2.1-1jpp
- First JPackage release
